console.log('what up');

// You can import API functions like this from D3.js.
import { select } from 'd3';

// Initialize a circle
var theCircle = d3
  .select('#dataviz_buttonEventListener')
  .append('svg')
  .append('circle')
  .attr('cx', 100)
  .attr('cy', 70)
  .attr('stroke', 'black')
  .style('fill', '#69b3a2')
  .attr('r', 20);

// A function that update the color circle
function changeSize() {
  theCircle.attr('r', this.value);
}

// Add an event listener to the button created in the html part
d3.select('#buttonSize').on('input', changeSize);

// Create data = list of groups
var allGroup = [
  'yellow',
  'blue',
  'red',
  'green',
  'purple',
  'black',
];

// Initialize the button
var dropdownButton = d3
  .select('#dataviz_builtWithD3')
  .append('select');

// add the options to the button
dropdownButton // Add a button
  // 'myOptions' is an empty selection 
  .selectAll('myOptions') // Next 4 lines add 6 options = 6 colors
  .data(allGroup)
  .enter()
  .append('option') // this is literally the option tag ... 
  //.join('what type of thing should you make') or  .join(" what HTML element are you making")
  // So we fill in the option tags with our data... 
  // so joining... is basically creating html elements with our data as values
  // ie. we let our data set the different HTML element attributes 
  //( thats what it means to join data to HTML elements)
  .text(function (d) { // set the text of the HTML element
    return d;
  }) // text showed in the menu
  .attr('value', function (d) {// set the value of the HTML element
    return d;
  }); // corresponding value returned by the button

// Initialize a circle
var zeCircle = d3
  .select('#dataviz_builtWithD3')
  .append('svg')
  .append('circle')
  .attr('cx', 100)
  .attr('cy', 70)
  .attr('stroke', 'black')
  .style('fill', 'yellow')
  .attr('r', 20);

// A function that update the color of the circle
function updateChart(mycolor) {
  zeCircle
    .transition()
    .duration(1000)
    .style('fill', mycolor);
}

// When the button is changed, run the updateChart function
dropdownButton.on('change', function (d) {
  // recover the option that has been chosen
  var selectedOption = d3.select(this).property('value');

  // run the updateChart function with this selected option
  updateChart(selectedOption);
});

//////////////////////////////////////////////

//          SLIDER

//////////////////////////////////////////////

// Position of the circles on the X axis
var position = [50, 150, 250, 350];

// Add circles at the top
var theCircles = d3
  .select('#dataviz_mySlider')
  .selectAll('mycircles')
  .data(position)
  .enter()
  .append('circle')
  .attr('cx', function (d) {
    return d;
  })
  .attr('cy', 100)
  .attr('r', 10);

// Function that change a color
function changeSizeSlider(size) {
  theCircles.attr('r', size);
}

// Listen to the slider?
d3.select('#mySlider').on('change', function (d) {
  console.log('eve');
  selectedValue = this.value;
  changeSizeSlider(selectedValue);
});
